#include <bits/stdc++.h>

using namespace std;

pair <int, int> build (int curr, vector <vector <int>> & g, int depth, int & res) {
    int max_depth1 = depth, max_depth2 = depth;
    for (auto elem : g[curr]) {
        int nw = build(elem, g, depth + 1, res).first;
        if (nw > max_depth1) {
            max_depth2 = max_depth1;
            max_depth1 = nw;
        }
        else if (nw > max_depth2) {
            max_depth2 = nw;
        }
    }
    res = max(res, max_depth1 - depth + 1 + max_depth2 - depth);
    return {max_depth1, max_depth2};
}

int main()
{
    int n, m; cin >> n >> m;
    vector <vector <int>> g(n);

    int p;
    int res = 0;
    for (int i = 2; i <= n; ++i)
    {
         cin >> p;
         g[p - 1].push_back(i - 1);
    }

    int depth = 0;
    pair <int, int> res1 = build (0, g, depth, res);
    cout << res << endl;

    return 0;
}
