#include <bits/stdc++.h>

using namespace std;

int finalize (vector <int> a, vector <int> & fnl) {
    int res = 0;
    for (int i = 0; i < (int)fnl.size(); ++i)
        if (a[i] != fnl[i]) ++res;
    return res;
}

void build (int curr, int & m, vector <pair <int, int>> & cuts, vector <int> a, vector <int> & fnl, int made, int & res) {
    if (curr == (int)cuts.size()) {
        made += finalize(a, fnl);
        res = min(res, made);
    }
    else {
        build(curr + 1, m, cuts, a, fnl, made, res);
        for (int i = 1; i <= m; ++i) {
            for (int j = cuts[curr].first; j <= cuts[curr].second; ++j)
                a[j] = i;
            build(curr + 1, m, cuts, a, fnl, made + 1, res);
        }
    }
}

int main()
{
    int k, n, m; cin >> k >> n >> m;

    vector <int> fnl;
    for (int i = 0; i < n; ++i) {
        int c, v; cin >> c >> v;
        for (int j = 0; j < c; ++j) {
            fnl.push_back(v);
        }
    }

    if (k == 0)
        cout << 1 << endl;
    else if (k == 1) {
        if (fnl[0] == fnl[1])
            cout << 1 << endl;
        else cout << 2 << endl;
    }
    else if (k == 2) {
        int res = (int)fnl.size();
        vector <pair <int, int>> cuts = {{0, 3}, {0, 1}, {2, 3}};
        vector <int> var((int)fnl.size(), 0);
        build(0, m, cuts, var, fnl, 0, res);
        cout << res << endl;
    }
    else if (k == 3) {
        int res = (int)fnl.size();
        vector <pair <int, int>> cuts = {{0, 7}, {0, 3}, {4, 7}, {0, 1}, {2, 3}, {4, 5}, {6, 7}};
        vector <int> var((int)fnl.size(), 0);
        build(0, m, cuts, var, fnl, 0, res);
        cout << res << endl;
    }

    return 0;
}
