#include <bits/stdc++.h>

using namespace std;

int finalize (vector <int> a, vector <int> & fnl) {
    int res = 0;
    for (int i = 0; i < (int)fnl.size(); ++i)
        if (a[i] != fnl[i]) ++res;
    return res;
}

void build (int curr, int & m, vector <pair <int, int>> & cuts, vector <int> a, vector <int> & fnl, int made, int & res) {
    if (curr == (int)cuts.size()) {
        made += finalize(a, fnl);
        res = min(res, made);
    }
    else {
        build(curr + 1, m, cuts, a, fnl, made, res);
        for (int i = 1; i <= m; ++i) {
            for (int j = cuts[curr].first; j <= cuts[curr].second; ++j)
                a[j] = i;
            build(curr + 1, m, cuts, a, fnl, made + 1, res);
        }
    }
}

int main()
{
    int k, n, m; cin >> k >> n >> m;

    vector <int> fnl;
    for (int i = 0; i < n; ++i) {
        int c, v; cin >> c >> v;
        for (int j = 0; j < c; ++j) {
            fnl.push_back(v);
        }
    }
    int sz = fnl.size();

    if (k == 0)
        cout << 1 << endl;
    else if (k == 1) {
        if (fnl[0] == fnl[1])
            cout << 1 << endl;
        else cout << 2 << endl;
    }
    else if (k >= 2) {
        int bal = 0;
        int res = 0;
        vector <int> var(sz, 0);
        for (int len = sz; len >= 1; len /= 2) {
            for (int i = 0; i < sz; i += len) {
                int bestDig = 0, bestCurr = 0;
                for (int dig = 1; dig <= m; ++dig)
                {
                    int curr = bal;
                    for (int p = i; p < i + len; ++p) {
                        if (var[p] == fnl[p] && dig != fnl[p])
                            --curr;
                        else if (var[p] != fnl[p] && dig == fnl[p])
                            ++curr;
                    }
                    if (curr > bestCurr) {
                        bestDig = dig;
                        bestCurr = curr;
                    }
                }
                if (bestCurr > bal) {
                for (int p = i; p < i + len; ++p)
                    var[p] = bestDig;
                ++res;
                }
            }
        }
        cout << res << endl;
    }

    return 0;
}
