#include <bits/stdc++.h>

using namespace std;

pair <int, int> build (int curr, vector <vector <int>> & g, int depth, int & res_with_one, int & res_with_two) {
    int max_depth1 = depth, max_depth2 = depth;
    for (auto elem : g[curr]) {
        int nw = build(elem, g, depth + 1, res_with_one, res_with_two).first;
        if (nw > max_depth1) {
            max_depth2 = max_depth1;
            max_depth1 = nw;
        }
        else if (nw > max_depth2) {
            max_depth2 = nw;
        }
    }
    if ((int)g[curr].size() == 1)
    res_with_one = max(res_with_one, max_depth1 - depth + 1 + max_depth2 - depth);
    else res_with_two = max(res_with_two, max_depth1 - depth + 1 + max_depth2 - depth);
    return {max_depth1, max_depth2};
}

int main()
{
    int n, m; cin >> n >> m;
    vector <vector <int>> g(n);

    int p;
    int res_with_one = 0, res_with_two = 0;
    for (int i = 2; i <= n; ++i)
    {
         cin >> p;
         g[p - 1].push_back(i - 1);
    }

    int depth = 0;
    pair <int, int> root_res = build (0, g, depth, res_with_one, res_with_two);
    cout << max(res_with_one, res_with_two) << endl;

    return 0;
}
